<?
/**
* UniWriter.class.php
* 
* 
*
* @author		Mark Sievers <msievers@uos.de> 
* @version		$Id: FHStudipWriter.class.php,v 1.1 2004/02/18 10:52:10 msievers Exp $
* @access		public
* @modulegroup	core
* @module			
* @package		studip_core
*/

// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// UniWriter.class.php
// This class gets a storageVector and writes it into the db
// Copyright (C) 2004 Mark Sievers <mark_sievers2000@yahoo.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

class UniWriter extends Writer {
    
    var $storage_array;
    var $current_sem_id;

    function UniWriter(&$config, $storage_vector) {
    	$this->config = $config;
        parent::Writer();
        $this->storage_vector = $storage_vector;
    }

    function setSeminar($seminar) {
        $sql_key_string = "("; 
        $sql_val_string = "(";
        foreach ($seminar as $key => $val) {
            $sql_key_string .= $key.","; 
            $sql_val_string .= "'".addslashes($val)."',";
        }
        $sql_key_string = substr($sql_key_string,0,strlen($sql_key_string)-1);
        $sql_val_string = substr($sql_val_string,0,strlen($sql_val_string)-1);
        $sql_key_string .= ")";
        $sql_val_string .= ")";
        $sql =  "INSERT INTO seminare ".
                $sql_key_string.
                " VALUES ".
                $sql_val_string;
        db_query($sql);
    }

    function setSeminarSemTree($sem_tree) {
        foreach ($sem_tree as $key => $val) {
            $sql =  "INSERT INTO seminar_sem_tree ".
                    "(sem_tree_id,seminar_id) ".
                    "VALUES ".
                    "('".$val["sem_tree_id"]."','".$this->current_sem_id."')";
            db_query($sql);
        }
    }

    function setDozenten($dozenten) {
        foreach ($dozenten as $key => $val) {
            $sql =  "INSERT INTO seminar_user ".
                    "(Seminar_id,user_id,status) ".
                    "VALUES ".
                    "('".$this->current_sem_id."','".$val["id"]."','dozent')";
            db_query($sql);
        }
    }

    function setSeminarInst($seminar_insts) {
		foreach($seminar_insts as $seminar_inst)
		{
			$sql =  "INSERT INTO seminar_inst ".
				"(seminar_id,institut_id) ".
				"VALUES ".
				"('".$this->current_sem_id."','".$seminar_inst."')";
			db_query($sql);
		}
    }

    function setGeneric($d_fields) {
        $sql_key_string = "(range_id,"; 
        $sql_val_string = "('".$this->current_sem_id."',";
        foreach ($d_fields as $key => $val) {
            $sql_key_string .= $key.","; 
            $sql_val_string .= "'".addslashes($val)."',";
        }
        $sql_key_string = substr($sql_key_string,0,strlen($sql_key_string)-1);
        $sql_val_string = substr($sql_val_string,0,strlen($sql_val_string)-1);
        $sql_key_string .= ")";
        $sql_val_string .= ")";
        $sql =  "INSERT INTO datafields_entries ".
                $sql_key_string.
                " VALUES ".
                $sql_val_string;
        db_query($sql);
    }


    function getSemesterId($beginn) {
        $sql =  "SELECT semester_id ".
                "FROM semester_data ".
                "WHERE beginn='".$beginn."'";
        $result = db_query($sql);
        $row = $result->nextRow();
        return $row["semester_id"];
    }

    function initWrite() {
        // fuer das Eintragen in die semester_seminar_order-Tabelle brauchen wir noch die ID des Semesters
        $semester_id = $this->getSemesterId($this->config->STARTTIME);
        foreach ($this->storage_vector->storage_array as $key => $val) {
            $this->current_sem_id = $val->getSeminarId();
            $this->setSeminar($val->seminar);
            $this->setSeminarSemTree($val->seminar_sem_tree);

            $this->setDozenten($val->dozent);
            $this->setSeminarInst($val->seminar_inst);
            foreach ($val->generic as $key2 => $val2) {
                $this->setGeneric($val2);
            }

        }
    }
}

?>
